## ViewFinder

ViewFinder is a UI and backend that turns headless Chrome into a regular browser, except the browser runs in the cloud not on your device. 

ViewFinder Community Edition can be used as a simple remote browser isolation application.

If you want a hosted or managed on-prem cloud-based internet isolation solution, email me at cris@dosycorp.com

## What is ViewFinder and Remote Browser isolation?

ViewFinder can be used as a [remote browser isolation](https://en.wikipedia.org/wiki/Browser_isolation) product. RBI means accessing the public internet through a browser that runs in the cloud, rather than through a browser that runs on your device. This helps protect you from attacks on the web.

This protects you from nearly all web-based hacks, such as viruses, ransomware, browser and device zero day exploits, and also helps protect you from tracking, by changing your device fingerprint and IP address. 

In more detail, the browser, normally is an executable application that runs on your device (phone, laptop). In RBI, instead you connect to a thin client web application that provides an interface to a browser that runs remotely. Remotely can mean in a VPS or VPC, in a physical box, or the public cloud. 

## Why is RBI significant?

And, if you're interested, read on for more detail.

It works by providing a thin client over the web that you connect your regular browser to. The thin client provides an interface to a remote browser that you interact with the browser the public internet.

This is significant because the internet is a cesspool of attacks. Malware, ransomware, virii, tracking, exploited PDFs, ways to deliver device zero days over the web, browser zero days. All these things can lead to the security of your device and network being compromised, causing significant inconvenience, distress and loss for you.

ViewFinder and the RBI methodology acknowledges that not all threats can be detected and neutralized (such as by virus scanners), in order to face that reality, RBI adopts a "isolation" posture towards threats, effectively isolating them in the remote machine and preventing them from reaching your device.

With ViewFinder, in order to render the content of a web page, the only thing we send to your device from the remote page is pixels. So no HTML, CSS, JavaScript, etc from your browsing is ever executed on your device.

[Cloud-based internet isolation](https://www.disa.mil/-/media/Files/DISA/Fact-Sheets/Cloud-Based-Internet-Isolation-CBII-Fact-Sheet20190721.ashx?la=en&hash=5DFC2594478284991F4B005AFA41DE26AC73D84A) is another name for this security practice and it is an emerging industry. Symantec recently acquired a company in this space, and Menlo Security [was awarded](https://www.menlosecurity.com/press-releases-blog/disa-cloud-based-internet-isolation-cbii-awarded-to-the-by-light-professional-it-services-llc-and-menlo-security-team) an agreement to build a CBII prototype for DISA, after a June 2018 request for RBI solutions that could eventually serve [60% of DoD's](https://web.archive.org/web/20191218141205/https://insidecybersecurity.com/sites/insidecybersecurity.com/files/documents/2018/aug/cs2018_0376.pdf)[~ 3 million users](https://en.wikipedia.org/wiki/Browser_isolation).
