export default function Landing(state) {
  const {Wrap} = state.boilerplate;
  
  return Wrap(state, "Remote Browser Isolation", `
        <section class=content>
          <section class=introduction tabindex=0>
            <div class=story>
              <h1>Welcome to Safe Browsing.</h1>
              <p>
                In a world of risks, we offer you the simplest and best browser isolation 
                platform. 
              </p>
            </div>
            <div class=graphic>
              <img src=/images/3rd-party/undraw/security.svg>
            </div>
          </section>
        </section>
     `,
     `
          <section class=content>
            <section class=introduction tabindex=0>
              <div class=graphic>
                <img src=/images/3rd-party/undraw/securityon.svg>
              </div>
              <div class=story>
                <h1>Customer-First Security.</h1>
                <p>
                  We put the customer first, and provide the 
                  most similar experience to browsing on your normal insecure browser, without
                  the risks. Our fault-tolerant browser-as-a-service infrastructure 
                  enables the secure and reliable provision of fully managed, 
                  fully hosted and fully remote cloud browsers, at whatever scale you require.
                  Our familiar web client looks and feels just like using your regular insecure browser, 
                  and runs in all modern and legacy platforms, no downloads required, even on mobile.
                </p>
              </div>
            </section>
            <section class=protection tabindex=0>
              <div class=story>
                <h1>More Private. More Secure. More Control.</h1>
                <p>
                  ViewFinder never runs any JavaScript, applets, CSS or HTML from the remote page on your machine or network. By totally isolating your infrastructure form the risks of the web, it means that malware, exploits, ransomware, adware and other web risks cannot harm you operations.
                </p>
              </div>
              <div class=graphic>
                <img src=/images/3rd-party/undraw/safe.svg>
              </div>
            </section>
            <section class=security tabindex=0>
              <div class=graphic>
                <img src=/images/3rd-party/undraw/container.svg>
              </div>
              <div class=story>
                <h1>The Highest Security. Complete Isolation.</h1>
                <p>
                  ViewFinder never runs any remote code on your machine. Ever. We never run any JavaScript, applets, CSS and not even one tag of HTML on your machine that comes from the remote browser. Our platform is the only browser isolation system that can run on any device, and never runs any code on your machine. We provide a fully interactive image of the remote web page, that looks and feels just like browsing on your favorite consumer browser, but without any of the regular risks associated with that. 
                </p>
              </div>
            </section>
            <section class=introduction tabindex=0>
              <hr class=diagonal>
              <div class=graphic>
                <img src=/images/3rd-party/undraw/future.svg>
              </div>
              <div class=story>
                <h1>What is Browser isolation?</h1>
                <p>
                  Browser isolation is a security practise where you isolate 
                  your network from the internet. All browsing is conducted over a secure channel, using an isolated, and remote, cloud browser. 
                </p>
              </div>
            </section>
            <section class=introduction tabindex=0>
              <div class=points>
                <h1>What is ViewFinder?</h1>
                <ul>
                  <li>Secure browsing, familiar interface. 
                  <li>Browser isolation vendor
                  <li>Cloud browser provider
                  <li>Remote browser product
                  <li>No install or download required.
                  <li>Browser-as-a-service
                </ul>
              </div>
              <div class=graphic>
                <img src=/images/3rd-party/undraw/question.svg>
              </div>
            </section>
            <section class=introduction tabindex=0>
              <div class=graphic>
                <img src=/images/3rd-party/undraw/helpfulsign.svg>
              </div>
              <div class=story>
                <h1>ViewFinder. The difference is the way it works.</h1>
                <p>
                  ViewFinder is just one of many browser isolation vendors. You should pick the best vendor for your particular needs. ViewFinder focuses on providing excellent customer support, and the most similar user interface and experience to a regular insecure browser, without the risks. 
                </p>
              </div>
            </section>
            <section class=security tabindex=0>
              <div class=points>
                <h1>How does ViewFinder protect my privacy and security?</h1>
                <ul>
                  <li>Remote cloud browsers
                  <li>Complete browser isolation
                  <li>Threat containment
                  <li>All execution happens in remote DMZ
                  <li>Codeless "interactive image" technology
                  <li>Zero trust security
                  <li>No JavaScript, cookies, HTML/CSS from the remote web page are sent to you, ever.
                </ul>
              </div>
              <div class=graphic>
                <img src=/images/3rd-party/undraw/privacy.svg>
              </div>
            </section>
            <section class=introduction tabindex=0>
              <div class=graphic>
                <img src=/images/3rd-party/undraw/undraw_hologram_fjwp.svg>
              </div>
              <div class=story>
                <h1>How does browser isolation help secure my network?</h1>
                <p>
                  Our full isolation system means never is any JavaScript code, images, HTML, CSS or other assets from a remote page sent to you. You interact with the internet via a secure layer, similar to a scientist doing experiments in a fume hood or hazmat isolation in a biological safety cabinet. The principle is very similar with our total isolation system ensuring a constant "negative pressure" from the web to you. Meaning that no web content actually reaches you, except via a holographic image of that content that is fully interactive yet totally inert. 
                </p>
              </div>
            </section>
            <section class=protection tabindex=0>
              <div class=points>
                <h1>What does ViewFinder stop?</h1>
                <ul>
                  <li>Zero-day exploits
                  <li>Malicious websites and webapps
                  <li>Browser exploitation
                  <li>Malware and viruses
                  <li>Device rootkits
                  <li>Adware and tracking
                  <li>Ransomware
                </ul>
              </div>
              <div class=graphic>
                <img src=/images/3rd-party/undraw/cleanup.svg>
              </div>
            </section>
            <section class=reliability tabindex=0>
              <div class=graphic>
                <img src=/images/3rd-party/undraw/mobilebrowsers.svg>
              </div>
              <div class=story>
                <h1>Looks and feels just like a normal browser.</h1>
                <p>
                  ViewFinder provides a fully interactive image of the remote web page, that looks and feels just like browsing on your favorite consumer browser, but without any of the regular risks associated with that. You can easily open new tabs, watch video (at a reduced frame rate), download files and even play audio.
                </p>
              </div>
            </section>
            <section class=reliability tabindex=0>
              <div class=points>
                <h1>How high-maintenance is ViewFinder?</h1>
                <ul>
                  <li>Fully managed
                  <li>Fully hosted
                  <li>Completely familiar browser interface
                  <li>Zero or minimal training required
                  <li>Per-seat, subscription pricing
                </ul>
              </div>
              <div class=graphic>
                <img src=/images/3rd-party/undraw/chill.svg>
              </div>
            </section>
            <section class=cta>
              <a href=#membership-application class="register toggle-opener">
                <span class=verbose-name>Apply for Membership</span> Now
              </a>
            </section>
          </section>
  `);
}
